/*
 * InitialSymbol.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travicek
 */

#include "InitialSymbol.h"
#include "Symbol.h"
#include <object/Object.h>
#include "UniqueSymbol.h"

#include <registration/ValuePrinterRegistration.hpp>

namespace alphabet {

InitialSymbol::InitialSymbol() {

}

SymbolBase* InitialSymbol::clone() const {
	return new InitialSymbol(*this);
}

SymbolBase* InitialSymbol::plunder() && {
	return new InitialSymbol(std::move(*this));
}

int InitialSymbol::compare(const InitialSymbol&) const {
	return 0;
}

void InitialSymbol::operator>>(std::ostream& out) const {
	out << "(InitialSymbol)";
}

InitialSymbol::operator std::string() const {
	return InitialSymbol::instance < std::string > ( );
}

SymbolBase* InitialSymbol::inc() && {
	return new UniqueSymbol(Symbol(std::move(*this)), primitive::Integer(0));
}

} /* namespace alphabet */

namespace {

static auto valuePrinter = registration::ValuePrinterRegister < alphabet::InitialSymbol > ( );

} /* namespace */
