/*
 * BottomOfTheStackSymbol.cpp
 *
 *  Created on: Jun 19, 2014
 *      Author: Jan Travnicek
 */

#include "BottomOfTheStackSymbol.h"
#include <alphabet/Symbol.h>
#include <object/Object.h>

#include <registration/XmlRegistration.hpp>

namespace alib {

alphabet::BottomOfTheStackSymbol xmlApi < alphabet::BottomOfTheStackSymbol >::parse ( ext::deque < sax::Token >::iterator & input ) {
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::END_ELEMENT, xmlTagName ( ) );
	return alphabet::BottomOfTheStackSymbol ( );
}

bool xmlApi < alphabet::BottomOfTheStackSymbol >::first ( const ext::deque < sax::Token >::const_iterator & input ) {
	return sax::FromXMLParserHelper::isToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );
}

const std::string & xmlApi < alphabet::BottomOfTheStackSymbol >::xmlTagName ( ) {
	static std::string xmlTagName = "BottomOfTheStackSymbol";

	return xmlTagName;
}

void xmlApi < alphabet::BottomOfTheStackSymbol >::compose ( ext::deque < sax::Token > & output, const alphabet::BottomOfTheStackSymbol & ) {
	output.emplace_back ( xmlTagName ( ), sax::Token::TokenType::START_ELEMENT );
	output.emplace_back ( xmlTagName ( ), sax::Token::TokenType::END_ELEMENT );
}

} /* namespace alib */

namespace {

static auto xmlWrite = registration::XmlWriterRegister < alphabet::Symbol, alphabet::BottomOfTheStackSymbol > ( );
static auto xmlWrite2 = registration::XmlWriterRegister < alib::Object, alphabet::BottomOfTheStackSymbol > ( );

static auto xmlReader = registration::XmlReaderRegister < alphabet::Symbol, alphabet::BottomOfTheStackSymbol > ( );
static auto xmlReaded2 = registration::XmlReaderRegister < alib::Object, alphabet::BottomOfTheStackSymbol > ( );

} /* namespace */
