/*
 * EpsilonNFA.cpp
 *
 *  Created on: Mar 25, 2013
 *      Author: Jan Travnicek
 */

#include "EpsilonNFA.h"
#include <automaton/Automaton.h>
#include <object/Object.h>

#include <registration/ValuePrinterRegistration.hpp>
#include <registration/XmlRegistration.hpp>
#include <registration/CastRegistration.hpp>

namespace {

static auto valuePrinter = registration::ValuePrinterRegister < automaton::EpsilonNFA < > > ( );

static auto xmlWrite = registration::XmlWriterRegister < automaton::Automaton, automaton::EpsilonNFA < > > ( );
static auto xmlWrite2 = registration::XmlWriterRegister < alib::Object, automaton::EpsilonNFA < > > ( );

static auto xmlReader = registration::XmlReaderRegister < automaton::Automaton, automaton::EpsilonNFA < > > ( );
static auto xmlReaded2 = registration::XmlReaderRegister < alib::Object, automaton::EpsilonNFA < > > ( );

static auto epsilonNFAFromDFA = registration::CastRegister < automaton::EpsilonNFA < >, automaton::DFA < > > ( );
static auto epsilonNFAFromNFA = registration::CastRegister < automaton::EpsilonNFA < >, automaton::NFA < > > ( );
static auto epsilonNFAFromMultiInitialStateNFA = registration::CastRegister < automaton::EpsilonNFA < >, automaton::MultiInitialStateNFA < > > ( );

} /* namespace */
