/*
 * PrefixRankedPattern.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include "PrefixRankedPattern.h"
#include <tree/Tree.h>
#include <tree/RankedTreeWrapper.h>
#include <object/Object.h>

#include <registration/ValuePrinterRegistration.hpp>
#include <registration/XmlRegistration.hpp>
#include <registration/CastRegistration.hpp>

namespace {

static auto valuePrinter = registration::ValuePrinterRegister < tree::PrefixRankedPattern < > > ( );

static auto xmlWrite = registration::XmlWriterRegister < tree::Tree, tree::PrefixRankedPattern < > > ( );
static auto xmlWrite2 = registration::XmlWriterRegister < tree::RankedTreeWrapper, tree::PrefixRankedPattern < > > ( );
static auto xmlWrite3 = registration::XmlWriterRegister < alib::Object, tree::PrefixRankedPattern < > > ( );

static auto xmlReader = registration::XmlReaderRegister < tree::Tree, tree::PrefixRankedPattern < > > ( );
static auto xmlReaded2 = registration::XmlReaderRegister < tree::RankedTreeWrapper, tree::PrefixRankedPattern < > > ( );
static auto xmlReaded3 = registration::XmlReaderRegister < alib::Object, tree::PrefixRankedPattern < > > ( );

static auto PrefixRankedPatternFromRankedPattern = registration::CastRegister < tree::PrefixRankedPattern < >, tree::RankedPattern < > > ( );
static auto PrefixRankedPatternFromPrefixRankedTree = registration::CastRegister < tree::PrefixRankedPattern < >, tree::PrefixRankedTree < > > ( );

} /* namespace */
