#ifndef AUTOMATON_TEST_H_
#define AUTOMATON_TEST_H_

#include <cppunit/extensions/HelperMacros.h>

class AutomatonTest : public CppUnit::TestFixture
{
  CPPUNIT_TEST_SUITE( AutomatonTest );
  CPPUNIT_TEST( testDFAParser );
  CPPUNIT_TEST( testNFAInsertTransitions );
  CPPUNIT_TEST( SinglePopDPDATransitions );
  CPPUNIT_TEST( DPDATransitions );
  CPPUNIT_TEST( testExtendedNFAAlphabet );
  CPPUNIT_TEST( testRHPDATransitions );
  CPPUNIT_TEST( testNPDATransitions );
  CPPUNIT_TEST( testNFTAParser );
  CPPUNIT_TEST( testNFTATransitions );
  CPPUNIT_TEST_SUITE_END();

public:
  void setUp();
  void tearDown();

  void testDFAParser();
  void testNFAInsertTransitions();
  void SinglePopDPDATransitions();
  void DPDATransitions();
  void testExtendedNFAAlphabet();
  void testRHPDATransitions();
  void testNPDATransitions();
  void testNFTAParser();
  void testNFTATransitions();
};

#endif  // AUTOMATON_TEST_H_
